/* som.c    main for som-language
	P. Chongstitvatana
	22 Oct 2002

	start Som project   			13 Sept 2003
	som v1  public release 			4 Dec 2004
	som-v15 rev2  seperate optim 	5 Mar 2005
	som-v16: hex, i-array, file i/o 6 Nov 2005
	som-v17 t-code					23 Dec 2005
	som-v24							1 Jan 2007 Happy New Year!
	som v3.0 sx-code				3 Mar 2007
*/

#include "compile.h"

FILE *FO, *FI;			// output/input file
int load_ads;			// base ads for fun "loadfile"
int CP = 1;				// current CS pointer

PRIVATE void error( char *mess ){
	printf("Error: %s\n",mess);
	exit(-1);
}

// make file.lst file.obj from file.xxx
PRIVATE void makename(char *src, char *obj, char *lst){
	int n;
	n = strcspn(src,".");
	strncpy(obj,src,n);
	strcpy(obj+n,".obj");
	strncpy(lst,src,n);
	strcpy(lst+n,".lst");
}

// make file.lst file.obj from file.xxx
PRIVATE void makename2( char *source){
	char obj[80], lst[80];
	makename(source,obj,lst);
	strpack(som_src,source);
	strpack(som_obj,obj);
	strpack(som_lst,lst);
}

PRIVATE void readCode(FILE *fi){
	int i, start, end, c;
	fscanf(fi,"%d%d",&start,&end);
	for(i=start; i<=end; i++){
		fscanf(fi,"%d",&c);
		CS[i] = c;
	}
	CP = end+1;
}

PRIVATE void readData(FILE *fi){
	int i, start, end, c;
	fscanf(fi,"%d%d",&start,&end);
	for(i=start; i<=end; i++){
		fscanf(fi,"%d",&c);
		M[i] = c;
	}
	DS = end+1;
}

PRIVATE void outa( int code, int arg){
	CS[CP] = (arg << 8 ) | (code & 255);
	CP++;
}

// read object file, code and data
PRIVATE void readobj(char *fn){
	int magic;
	FI = fopen(fn,"r");
	fscanf(FI,"%d",&magic);
	if(magic != OBJ_SOM30)
		error("not som 3.0 object");
	readCode(FI);
	readData(FI);
}

PRIVATE void execute(char *obj){
	readobj(obj);
	fclose(FI);
	eval(1);
	#ifdef PROF
		report();
	#endif
}

PRIVATE void doSom(void){
	int i, n, type, ref, arg, v;
	char name[NAMELEN];

	readobj("som0.obj");	// execute("som.obj");
	fscanf(FI,"%d",&n);		// find ads of "loadfile"
	for(i=0; i<n; i++){
		fscanf(FI,"%s%d%d%d%d",name,&type,&ref,&arg,&v);
		if(eqs(name,"loadfile")) break;
	}
	if(i == n)
		error("not found loadfile");
	load_ads = CP;
	outa(icCall,ref);	// gen "call loadfile, end"
	outa(icEnd,0);
	fclose(FI);
	eval(1);
	#ifdef PROF
		report();
	#endif
}

// ---------- string functions ----------

// pack C-string (char *) to S-string in M[] indexed by s1
void strpack(int s1, char *s2){
	uchar c1, c2, c3, c4;
	while( *s2 != 0 ){
		c1 = (*s2 != 0) ? *s2++ : 0;
		c2 = (*s2 != 0) ? *s2++ : 0;
		c3 = (*s2 != 0) ? *s2++ : 0;
		c4 = (*s2 != 0) ? *s2++ : 0;
		M[s1] = (((((((int)c1)<<8)|(int)c2)<<8)|
			(int)c3)<<8)|(int)c4;
		s1++;
	}
	M[s1] = 0;
}

// convert som-string to C-string
void strunpack(char *s1, int s2){
	int s;
	char c1, c2, c3, c4;
	while( M[s2] != 0 ){
		s = M[s2];
		c1 = (char)((s >> 24) & 255);
		c2 = (char)((s >> 16) & 255);
  		c3 = (char)((s >> 8) & 255);
   		c4 = (char)(s & 255);
   		if( c1 != 0 ) *s1++ = c1;
		if( c2 != 0 ) *s1++ = c2;
		if( c3 != 0 ) *s1++ = c3;
		if( c4 != 0 ) *s1++ = c4;
		s2++;
	}
	*s1 = 0;
}
/*
void prstr(int i){
	int c1,c2,c3,c4;

	while( M[i] != 0 ){
		c1 = (M[i] >> 24) & 255;
		c2 = (M[i] >> 16) & 255;
		c3 = (M[i] >> 8) & 255;
		c4 = M[i] & 255;
		if( c1 != 0 ) printf("%c",c1);
		if( c2 != 0 ) printf("%c",c2);
		if( c3 != 0 ) printf("%c",c3);
		if( c4 != 0 ) printf("%c",c4);
		i++;
	}
}
*/
// op code printing for profiling
PRIVATE char op_str[][8] = {
	"Undef","Add","Sub","Mul","Div","Band","Bor","Bxor","Mod",
	"Eq","Ne","Lt","Le","Ge","Gt","Shl","Shr",
	"Undef","Undef","Undef","Undef",
	"Addv","Subv","Mulv","Divv","Bandv","Borv","Bxorv","Modv",
	"Eqv","Nev","Ltv","Lev","Gev","Gtv","Shlv","Shrv",
	"Undef","Undef","Undef","Undef",
	"Addi","Subi","Muli","Divi","Bandi","Bori","Bxori","Modi",
	"Eqi","Nei","Lti","Lei","Gei","Gti","Shli","Shri",
	"Undef","Undef","Undef","Undef",
	// one arg
	"Get","Put","Ld","St","Ldx","Stx","Ldy","Sty",
	"Jmp","Jt","Jf","Call","Ret","Undef","Efor",
	"Inc","Dec","Lit","Ads","Sys","Fun","Calli",
	// zero arg
	"Not","Case","End",
};

void prCode2(FILE *fo, int op){
	fprintf(fo,"%s",op_str[op]);
}
// ----------------------

void Usage(void){
	printf("%s\n%s\n%s\n%s\n",
		"som          interactive mode",
		"som file     compile and run, output .lst and .obj",
		"som -x file  execute obj file",
		"som -?       this help");
	exit(0);
}

// mode 1 interactive, 2 compile&run, 3 execute,
int main( int argc, char *argv[] ){
	int i, mode;

	mode = 2;
	for (i=1; i<argc; i++) {
		if (argv[i][0] == '-') {
			switch (argv[i][1]) {
			case '?': Usage(); break;
			case 'x': mode = 3; break;
			default:
				fprintf(stderr,"unknown option %s\n",argv[i]);
				exit(0);
			}
		}else
			break;   // first non option
	}
	if(argc == 1) mode = 1;
	// argv[i] is the first arg, source file
	switch(mode){
	case 1:
		initfile();
		M[MODE_ADS] = 1;
		doSom();
		break;
	case 2:
		initfile();
		M[MODE_ADS] = 2;
		makename2(argv[i]);
		doSom();
		break;
	case 3:
		initfile();
		execute(argv[i]);
		break;
	}
	return 0;
}
